<template>
  <v-row justify="center" align="center">
    <v-col v-if="movie" cols="12" sm="10" md="10">
      <v-card class="py-2 my-5" outlined>
        <v-row>
          <v-col cols="2">
            <v-card-actions class="px-5">
              <v-btn
                color="primary"
                elevation="0"
                :to="`/`"
                block
              >
                <v-icon small class="mr-3">mdi-arrow-u-left-top</v-icon>
                <span>Back</span>
              </v-btn>
            </v-card-actions>
          </v-col>
          <v-col cols="10">
            <v-card-title>{{ movie.title }}</v-card-title>
            <v-card-subtitle>{{ movie.tagline }}</v-card-subtitle>
          </v-col>
        </v-row>
      </v-card>
      <v-card class="my-5" outlined>
        <v-row no-gutters>
          <v-col cols="3" class="pa-3">
            <v-img :src="`https://image.tmdb.org/t/p/w500${movie.poster_path}`" class="rounded"></v-img>
          </v-col>
          <v-col cols="9" class="pa-5">
            <v-sheet class="d-flex justify-space-between my-2">
              <v-sheet><span class="font-weight-bold">Budget:</span></v-sheet>
              <v-sheet>$ {{ movie.budget }}</v-sheet>
            </v-sheet>
            <v-sheet class="d-flex justify-space-between my-2">
              <v-sheet><span class="font-weight-bold">Revenue:</span></v-sheet>
              <v-sheet>$ {{ movie.revenue }}</v-sheet>
            </v-sheet>
            <v-sheet class="d-flex justify-space-between my-2">
              <v-sheet><span class="font-weight-bold">Release Date:</span></v-sheet>
              <v-sheet>{{ movie.release_date }}</v-sheet>
            </v-sheet>
            <v-sheet class="d-flex justify-space-between my-2">
              <v-sheet><span class="font-weight-bold">Runtime:</span></v-sheet>
              <v-sheet>{{ movie.runtime }}</v-sheet>
            </v-sheet>
            <v-sheet class="d-flex justify-space-between my-2">
              <v-sheet><span class="font-weight-bold">Score:</span></v-sheet>
              <v-sheet>{{ movie.vote_average }} <span class="text-caption">({{ movie.vote_count }})</span></v-sheet>
            </v-sheet>
            <v-sheet class="d-flex justify-space-between my-2">
              <v-sheet><span class="font-weight-bold">Runtime:</span></v-sheet>
              <v-sheet>{{ movie.runtime }}</v-sheet>
            </v-sheet>
            <v-sheet class="d-flex justify-space-between my-2">
              <v-sheet><span class="font-weight-bold">Genres:</span></v-sheet>
              <v-sheet>{{ genresText }}</v-sheet>
            </v-sheet>
            <v-sheet class="d-flex justify-space-between my-2">
              <v-sheet><span class="font-weight-bold">IMDB Link:</span></v-sheet>
              <v-sheet>
                <v-btn :href="`https://www.imdb.com/title/${movie.imdb_id}/`" text plain color="primary">LINK</v-btn>
              </v-sheet>
            </v-sheet>
            <v-sheet class="d-flex justify-space-between my-n3">
              <v-sheet><span class="font-weight-bold">Homepage Link:</span></v-sheet>
              <v-sheet>
                <v-btn :href="`${movie.homepage}`" text plain color="primary">LINK</v-btn>
              </v-sheet>
            </v-sheet>
          </v-col>
        </v-row>
      </v-card>
      <v-card class="my-5" outlined>
        <v-card-text>
          {{ movie.overview }}
        </v-card-text>
      </v-card>
      <v-card class="my-5" outlined>
        <v-card-title>Credit:</v-card-title>
        <v-card-text>
          {{ creditsText }}
        </v-card-text>
      </v-card>
    </v-col>
  </v-row>
</template>
<script>
import {mapState} from "vuex";
import MovieService from "~/services/MovieService";

export default {
  name: 'MoviePage',
  data() {
    return {
      movie: null,
      credits: null
    }
  },
  computed: {
    ...mapState({
      genres: (state) => state.genres.genres,
    }),
    genresText() {
      if (this.movie) {
        return this.movie.genres.map((item) => {
          return item.name
        }).join(', ')
      } else {
        return null
      }
    },
    creditsText() {
      return this.credits ? this.credits.map((item) => item.name).join(', ') : null
    }
  },
  async mounted() {
    const id = this.$route.params.id
    const movie = await MovieService.getMovie(id)
    this.movie = movie.data
    const credits = await MovieService.getCredit(id)
    this.credits = credits.data.cast
  }
}
</script>
